/*******************************************************************************
 * Copyright(c) 2022 dongke All rights reserved. / Confidential
 * 类的信息：
 *		1.程序名称：  收款单列表
 * 编辑履历：
 *		作者				日期					版本				修改内容
 *		姜永辉      2024-03-22    1.00		   	    
 *******************************************************************************/
const Constants = require('@/utils/Constants.js');
const mixins = require('@/mixins/index.js')
Page({
  mixins: [mixins],
  /**
   * 页面的初始数据
   */
  data: {
    // 查询条件
    searchContent: [
      {
        code: 'makeTime', title: mixins.$t('pastThirthtyDays'),
        defaultValue: 5, searchType: Constants.searchType.date
      },
      { code: 'settlement', title: mixins.$t('settlement'),  dropType: 'settlement',searchType: Constants.searchType.dropSingle },
    ],
    // 列表区（内容）
    contentList: [
      { name: 'cusPhone', title: mixins.$t('cusPhone') },
      {
        name: [{ name: 'orgName', title: '' },
        { name: 'staffName', title: '' },],
        title: mixins.$t('receiptInfo')
      },
      { name: 'sumAmtReceivableHandle', title: mixins.$t('amountCollected') },
    ],
    // 弹出按钮
    buttonList: [],

    // 底部保存按钮
    buttonFootList: [],
    // 列表区（脚部金额）
    footerAmount: {
    },
    // 列表区（脚部信息）
    footerInfo: [{ name: 'sumAmtRec', }],
    contentnFootList: [],
    btnFormData: null,
    // 路由
    routeObjName: 'receiptPayment',
    // 主键Id
    primaryKey: 'rpId',

  },

  /**
  * @desc : 设置查询参数
  * @date : 2024年3月8日
  * @author : 姜永辉
  */
  setSearchParams(params) {
    //收付款类型-收款的查询参数
    params.rpType = Constants.rpType.receipt
    params.staffIdList = params.staffIds
    params.orgIdList = params.orgIds
     
    return params;
  },

  /** 
   * @desc : 查询 
   * @date : 2024年3月8日
   * @author : 姜永辉
   */
  getData(params) {
    return this.excute(this.data.service, this.data.service.selectByCond, params);
  },

  /**
     * @desc :   处理接口返回数据
     * @date : 2024年3月8日
     * @author : 姜永辉
     */
  handleSearchData(tableData) {
    let temp = tableData
    let contentnFootList = this.data.contentnFootList
    console.log(tableData);
    temp.forEach(it => {
      it.makeTime = it.makeTime.substring(0, 10)
      it.sumAmtReceivableHandle = it.sumAmtReceivableHandle != null ? Number(it.sumAmtReceivableHandle).toFixed(2) : '0.00'
      // 不加这个字段不显示收款字样
      it.collectStatus = ' '
    })
    let sumAmount = 0 //总的 合计金额 
    let sumQty = 0 //总的 合集数量
    sumAmount = tableData.sum('sumAmtRec')
    sumQty = tableData.sum('sumAmtReceivableHandle')

    contentnFootList.forEach(it => {
      if (it.type == 'count') {
        it.bill = tableData.length
      }
      if (it.type == 'number') {
        it.content = sumAmount
      }
    })

    this.setData({
      tableData: temp,
      sumAmount,
      sumQty,
      contentnFootList
    })
  },

  /**
    * @desc : （客户退款）-退收款单
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
  cusReturnCollection(e) {
    let item = e
    wx.navigateTo({
      url: this.data.route.addReturn.url,
      events: {
        // 回调后，在这里给页面赋值
        bandData: function (e) { }
      },
      success: function (res) {
        res.eventChannel.emit('params', {
          item: item,
          formType: 5,
          formMode: Constants.formMode.add
        })
      }
    })

  },

  /**
    * @desc : （编辑）
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
  editOrder(e) {
    let item = e
    let id = item.rpId
    // 收款
    if (item.rpType == Constants.rpType.receipt) {
      wx.navigateTo({
        url: this.data.route.add.url,
        events: {
          // 回调后，在这里给页面赋值
          bandData: function (e) { }
        },
        success: function (res) {
          res.eventChannel.emit('params', {
            id: id,
            formMode: Constants.formMode.edit
          })
        }
      })
    }
    // 退收款
    else if (item.rpType == Constants.rpType.returnReceipt) {
      wx.navigateTo({
        url: this.data.route.addReturn.url,
        events: {
          // 回调后，在这里给页面赋值
          bandData: function (e) { }
        },
        success: function (res) {
          res.eventChannel.emit('params', {
            id: id,
            formMode: Constants.formMode.edit
          })
        }
      })
    }

  },
 
})